#include <stdio.h>
#include <stdlib.h>
#include <err.h>

/* Exercice 1 */
#include <stdint.h>
int32_t *lireTab(char *filename) {
  FILE *fd = fopen(filename,"r");
  if(fd==NULL) err(1, "fopen");
  fseek(fd, 0, SEEK_END);
  long taille = ftell(fd);
  rewind(fd);
  int *tab=(int *)malloc(taille);
  if(fread(tab, 4, taille/4, fd) != taille/4)
    err(1,"fread");
  fclose(fd);
  return tab;
}

/* Exercice 4 */
struct noeud {
  struct noeud *frere;
  struct noeud *aine;
  double val;
};
  
void ajoutNoeud(struct noeud *pere, double val) {
  if(pere==NULL)
    errx(1,"ajout d'un fils a NULL");
  struct noeud *nouv = calloc(1, sizeof(struct noeud));
  nouv->val = val;
  nouv->frere = pere->aine;
  pere->aine = nouv;
}

int recherche(struct noeud *racine, double val) {
  if(racine == NULL) return 0;
  else if (racine->val == val) return 1;
  else return recherche(racine->aine, val) || recherche (racine->frere, val);
}

int prof(struct noeud *racine)
{
  if(racine==NULL) return 0;  // arbre vide a profondeur 0
  int profFils = prof(racine->aine);
  int profFrere = prof(racine->frere);
  // prf d'un noeud est max de celle de son frere cadet, et 1+ son sous arbre
  if(profFils +1 > profFrere)
    return profFils +1;
  else
    return profFrere;
}

    
/* Exercice 5 */
void rec(FILE *in, FILE*out) 
{
  char s[81];
  if(fgets(s, 81, in) != NULL) {
    rec(in, out);
    fputs(s, out);
  }
}
      
  

int main(int argc, char **argv)
{
  if(argc!=3)
    errx(0,"Usage: %s infile outfile", argv[0]);
  FILE *in = fopen(argv[1], "r"), *out=fopen(argv[2], "w");
  if(in==NULL || out==NULL)
    err(1,"fopen");
  rec(in, out);
  fclose(in);
  fclose(out);
  return 0;
}
