#include <stdio.h>
#include <stdlib.h>
#include <err.h>

void err2(char *msg) {
  fputs(msg,stderr);
  exit(1);
}

/* Exercice 2 */
size_t taille(char *filename) {
  FILE *f = fopen(filename, "r");
  if(f==NULL)
    err(1, "erreur fopen %s", filename);
  if(fseek(f,0,SEEK_END) == -1)
    err(1, "erreur fseek");
  size_t s = (size_t) ftell(f);
  if(s == -1)
    err(1, "erreur ftell");
  fclose(f);
  return s;
}

/* Exercice 3 */
int **pascal(int nblignes) {
  if(nblignes<0)
    err2("Erreur, argument negatif\n");
  int **C = (int **) malloc(nblignes*sizeof(int *));
  int n,p;
  for(n=0;n<nblignes;n++) {
    C[n] = (int *) malloc((n+1)*sizeof(int));
    C[n][0] = C[n][p] = 1;
    for(p=1;p<n;p++)
      C[n][p] = C[n-1][p] + C[n-1][p-1] ;
  }
  return C;
}

/* Exercice 4 */
int main(int argc, char **argv) {
  if(argc !=3)
    err2("Erreur il faut donner deux noms de fichier\n");
  FILE *rle = fopen(argv[1],"r");
  if(rle==NULL)
    err(1,"fopen de %s", argv[1]);
  FILE *fout = fopen(argv[2],"w");
  if(fout==NULL)
    err(1,"fopen de %s", argv[2]);
  signed char n, c, buf[128];
  int i;
  while(1)  {
    if(fread(&n,1,1,rle) != 1)
      break;
    if(n==0)
      err2("Erreur format RLE multiplicateur nul\n");
    else if(n>0)  {
      if(fread(buf, 1, n, rle) != n)
	err2("Erreur format RLE fin de fichier prematuree\n");
    }
    else {
      if( fread(&c, 1, 1, rle) != 1)
	err2("Erreur format RLE fin de fichier prematuree\n");
      n = -1 * n;
      for(i=0;i<n;i++)
	buf[i] = c;
    }
    if( fwrite(buf, 1, n, fout)!=n)
      err(1, "fwrite %s", argv[2]);
  }
  fclose(fout);
  fclose(rle);
  return 0;
}

/* Exercice 5 */
struct noeud {
  struct noeud *gauche;
  struct noeud *droite;
  char *mot;
};

int profondeur(struct noeud *n) {
  if(n==NULL) return -1;
  int pg = profondeur(n->gauche);
  int pd = profondeur(n->droite);
  return 1 + ( pg > pd ? pg : pd );
}

void affarbreAux(struct noeud *n, int p) {
  if(n != NULL) {
    if(p==0)
      printf("%s ", n->mot);
    else {
      affarbreAux(n->gauche, p-1);
      affarbreAux(n->droite, p-1);
    }
  }
}
   
void affarbre(struct noeud *r) {
  int prof = profondeur(r);
  int p;
  for(p = prof ; p >= 0 ; p--) 
    affarbreAux(r, p);
}
  
  
